/*
 *Programmer: Zhenming Zhao
 *Date: 02/06/2003
 *
 *Purpose: To serve as a worksheet processing program which can modify the
 *	       the values based on user requirements.
 *
 *Usage:
 *	 java Origin **input**.txt **output**.txt interval exponentail(2/3) 
 *
 *Algorithm:
 *
 *1. User inputs 4 arguments: the processing file name, the new generated file
 *   name, a number (n) which indicates how mnay lines should be in the first 
 *	 interval and it should be increased in the later intervals (currently 
 *   n * 2/3 exponential), a number (m) which indicates how many lines need to
 *   be divided in the first step and it needs to be gradually increased 
 *	 (m exponential),  
 *
 *2. Read the file and write a new file
 *
 *   m = 2 -> the 1st read reaches n * 3 ^ 0 lines-> read 2 ^ 0 lines each time 
 *   (if 2 ^ 0 == 1)  -> write out	 
 *   
 *   m = 2 -> add 2 lines to be spacer, the 2nd read reaches n * 3 ^ 1 lines -> 
 *   read 2 ^ 1 lines each time to 2 ^ 1 strings -> partition the values to 
 *   2 ^ 1 arrays -> calculate the average of the array for each index -> write
 *   out
 *
 *   m = 2 -> add 2 lines to be spacer, the 3rd read reaches n * 3 ^ 2 lines -> 
 *   read 2 ^ 2 lines each time to 2 ^ 2 strings -> partition the values to 
 *   2 ^ 2 arrays -> calculate the average of the array for each index -> write
 *   out
 *
 *   m = 2 -> add 2 lines to be spacer, the 4rd read reaches n * 3 ^ 3 lines -> 
 *   read 2 ^ 3 lines each time to 2 ^ 3 strings -> partition the values to 
 *   2 ^ 3 arrays -> calculate the average of the array for each index -> write
 *   out
 *	 .
 *	 .
 *	 .
 *   m = 2 -> x read -> n * 3 ^ (x-1) -> 2 ^ (x-1)	
 *
 *4. Close reading file and writing file
 *
 *
 */
 
import java.io.*;
import java.util.*;
import java.util.regex.*;


public class Origin {
		 
  public static void main(String[] args) {
    int LIMIT = 100000;
    int MAX = 100000;  //the max rows
    int INTEXP = 10;
    int ARRAYLEN = 30; //the max columns
    
    String eachLine[] = new String [MAX]; 
    String newLine = "", firstLine;
    int intLines, index = 0, count = 0;
   	double[] valueSum;
   	String[][] items = new String[LIMIT][ARRAYLEN];
   	String[]item = new String[ARRAYLEN];
   	int div = Integer.parseInt(args[3]);
    int interval = Integer.parseInt(args[2]);	
    
    Pattern p = Pattern.compile( "," );
   
    try {  
      RandomAccessFile data  = new RandomAccessFile( args[0], "r");
      PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter
                        (new File( args[1] ))));
           
      while( (firstLine=data.readLine()) != null) {
        count++;
        if( count == 1 ) {
        	item = p.split( firstLine );
        }	
      } 
      data.seek(0);
      
      valueSum = new double[item.length];
      
      for( int m = 1; m <= count; m++ ) {
        eachLine[m] = data.readLine();
        index++;
        
        if( index <= (interval*Math.pow(div, 0)+2) ) {
          if( index == 3 )
          	out.write( "\n" + eachLine[m] + "\n" );
          else
          	out.write( eachLine[m] + "\n" ); 
        }     
        else {
          if( index <= (interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +2)) {
            if( (index-2) % div == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
          else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) )) {
            if( (index-2) % Math.pow(div, 2) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
          else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) )) {
            if( (index-2) % Math.pow(div, 3) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
          else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) )) {
            if( (index-2) % Math.pow(div, 4) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
          else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5))) {
            if( (index-2) % Math.pow(div, 5) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
          else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6))) {
            if( (index-2) % Math.pow(div, 6) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
          else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6) + interval * Math.pow(div, 7))) {
            if( (index-2) % Math.pow(div, 7) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
          else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6) + interval * Math.pow(div, 7) +
          							interval * Math.pow(div, 8))) {
            if( (index-2) % Math.pow(div, 8) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
          else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6) + interval * Math.pow(div, 7) +
          							interval * Math.pow(div, 8) + interval * Math.pow(div, 9))) {
            if( (index-2) % Math.pow(div, 9) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
          else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6) + interval * Math.pow(div, 7) +
          							interval * Math.pow(div, 8) + interval * Math.pow(div, 9) +
          							interval * Math.pow(div, 10))) {
            if( (index-2) % Math.pow(div, 10) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
          else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6) + interval * Math.pow(div, 7) +
          							interval * Math.pow(div, 8) + interval * Math.pow(div, 9) +
          							interval * Math.pow(div, 10) + interval * Math.pow(div, 11))) {
            if( (index-2) % Math.pow(div, 11) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
          else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6) + interval * Math.pow(div, 7) +
          							interval * Math.pow(div, 8) + interval * Math.pow(div, 9) +
          							interval * Math.pow(div, 10) + interval * Math.pow(div, 11) +
          							interval * Math.pow(div, 12))) {
            if( (index-2) % Math.pow(div, 12) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
          else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6) + interval * Math.pow(div, 7) +
          							interval * Math.pow(div, 8) + interval * Math.pow(div, 9) +
          							interval * Math.pow(div, 10) + interval * Math.pow(div, 11) +
          							interval * Math.pow(div, 12) + interval * Math.pow(div, 13))) {
            if( (index-2) % Math.pow(div, 13) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
          else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6) + interval * Math.pow(div, 7) +
          							interval * Math.pow(div, 8) + interval * Math.pow(div, 9) +
          							interval * Math.pow(div, 10) + interval * Math.pow(div, 11) +
          							interval * Math.pow(div, 12) + interval * Math.pow(div, 13) +
          							interval * Math.pow(div, 14))) {
            if( (index-2) % Math.pow(div, 14) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
          else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6) + interval * Math.pow(div, 7) +
          							interval * Math.pow(div, 8) + interval * Math.pow(div, 9) +
          							interval * Math.pow(div, 10) + interval * Math.pow(div, 11) +
          							interval * Math.pow(div, 12) + interval * Math.pow(div, 13) +
          							interval * Math.pow(div, 14) + interval * Math.pow(div, 15))) {
            if( (index-2) % Math.pow(div, 15) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
          else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6) + interval * Math.pow(div, 7) +
          							interval * Math.pow(div, 8) + interval * Math.pow(div, 9) +
          							interval * Math.pow(div, 10) + interval * Math.pow(div, 11) +
          							interval * Math.pow(div, 12) + interval * Math.pow(div, 13) +
          							interval * Math.pow(div, 14) + interval * Math.pow(div, 15) +
          							interval * Math.pow(div, 16))) {
            if( (index-2) % Math.pow(div, 16) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
          else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6) + interval * Math.pow(div, 7) +
          							interval * Math.pow(div, 8) + interval * Math.pow(div, 9) +
          							interval * Math.pow(div, 10) + interval * Math.pow(div, 11) +
          							interval * Math.pow(div, 12) + interval * Math.pow(div, 13) +
          							interval * Math.pow(div, 14) + interval * Math.pow(div, 15) +
          							interval * Math.pow(div, 16) + interval * Math.pow(div, 17) +
									interval * Math.pow(div, 18))) {
            if( (index-2) % Math.pow(div, 18) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
		  else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6) + interval * Math.pow(div, 7) +
          							interval * Math.pow(div, 8) + interval * Math.pow(div, 9) +
          							interval * Math.pow(div, 10) + interval * Math.pow(div, 11) +
          							interval * Math.pow(div, 12) + interval * Math.pow(div, 13) +
          							interval * Math.pow(div, 14) + interval * Math.pow(div, 15) +
          							interval * Math.pow(div, 16) + interval * Math.pow(div, 17) +
									interval * Math.pow(div, 18) + interval * Math.pow(div, 19))) {
            if( (index-2) % Math.pow(div, 19) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
		  else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6) + interval * Math.pow(div, 7) +
          							interval * Math.pow(div, 8) + interval * Math.pow(div, 9) +
          							interval * Math.pow(div, 10) + interval * Math.pow(div, 11) +
          							interval * Math.pow(div, 12) + interval * Math.pow(div, 13) +
          							interval * Math.pow(div, 14) + interval * Math.pow(div, 15) +
          							interval * Math.pow(div, 16) + interval * Math.pow(div, 17) +
			  interval * Math.pow(div, 18) + interval * Math.pow(div, 19)+
			  interval * Math.pow(div, 20))) {
            if( (index-2) % Math.pow(div, 20) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
		  else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6) + interval * Math.pow(div, 7) +
          							interval * Math.pow(div, 8) + interval * Math.pow(div, 9) +
          							interval * Math.pow(div, 10) + interval * Math.pow(div, 11) +
          							interval * Math.pow(div, 12) + interval * Math.pow(div, 13) +
          							interval * Math.pow(div, 14) + interval * Math.pow(div, 15) +
          							interval * Math.pow(div, 16) + interval * Math.pow(div, 17) +
			  interval * Math.pow(div, 18) + interval * Math.pow(div, 19) +
			  interval * Math.pow(div, 20)+ interval * Math.pow(div, 21))) {
            if( (index-2) % Math.pow(div, 21) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
		  else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6) + interval * Math.pow(div, 7) +
          							interval * Math.pow(div, 8) + interval * Math.pow(div, 9) +
          							interval * Math.pow(div, 10) + interval * Math.pow(div, 11) +
          							interval * Math.pow(div, 12) + interval * Math.pow(div, 13) +
          							interval * Math.pow(div, 14) + interval * Math.pow(div, 15) +
          							interval * Math.pow(div, 16) + interval * Math.pow(div, 17) +
			  interval * Math.pow(div, 18) +interval * Math.pow(div, 19) +
			  interval * Math.pow(div, 20) + interval * Math.pow(div, 21) +
			  interval * Math.pow(div, 22))) {
            if( (index-2) % Math.pow(div, 22) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
		  else if( index <= (2 + interval*Math.pow(div, 0) + interval * Math.pow(div, 1) +
          							interval * Math.pow(div, 2) + interval * Math.pow(div, 3) +
          							interval * Math.pow(div, 4) + interval * Math.pow(div, 5) +
          							interval * Math.pow(div, 6) + interval * Math.pow(div, 7) +
          							interval * Math.pow(div, 8) + interval * Math.pow(div, 9) +
          							interval * Math.pow(div, 10) + interval * Math.pow(div, 11) +
          							interval * Math.pow(div, 12) + interval * Math.pow(div, 13) +
          							interval * Math.pow(div, 14) + interval * Math.pow(div, 15) +
          							interval * Math.pow(div, 16) + interval * Math.pow(div, 17) +
			  interval * Math.pow(div, 18) + interval * Math.pow(div, 19) +
			  interval * Math.pow(div, 20) + interval * Math.pow(div, 21) +
			  interval * Math.pow(div, 22) + interval * Math.pow(div, 23))) {
            if( (index-2) % Math.pow(div, 23) == 0 ) {
              for( int i = index; i > (index - div); i-- ) {
              	items[i] = p.split( eachLine[i] );
               	
               	for( int j = 0; j < items[i].length; j++ ) {
               		valueSum[j] = valueSum[j] + Double.parseDouble(items[i][j]);
                }	
              } 	  
              for( int i = 0; i < valueSum.length; i++ ) {
                if( i == (valueSum.length -1) ) {
                  newLine = newLine + valueSum[i]/div;
                  //System.out.println( "" + valueSum.length );		
                }    
                else
                    newLine = newLine + valueSum[i]/div + ",";
                
                valueSum[i] = 0.0;     
              }
              out.write( newLine + "\n" );
              newLine = "";
            }	
          }
		  
        } 	 
      } 
      out.close();
      data.close();  
    }
    catch( Throwable e ) {
      System.err.println( e );
    }
  }
}